import type { TRole } from "@hiveio/wax";

export type KeyIndex = {
  accountIndex?: number;
  role: TRole;
}

export type PrivateKeyData = Required<KeyIndex> & {
  privateKey: string;
  publicKey: string;
}

export type GetPrivateKeysRequest = {
  method: 'hive_getPrivateKeys';
  params: {
    keys: KeyIndex[];
  };
};

export type GetPrivateKeysResponse = {
  keys: PrivateKeyData[];
};

export type RpcRequest = GetPrivateKeysRequest;
export type RpcResponse = GetPrivateKeysResponse;
