import { Bold, Text, Box, Italic } from "@metamask/snaps-sdk/jsx";
import { KeyIndex } from "../../rpc";

export const ConfirmGetPrivateKeys = (origin: string, keys: KeyIndex[]) => snap.request({
  method: 'snap_dialog',
  params: {
    type: 'confirmation',
    content: (
      <Box>
        <Text>
          <Bold>{ origin }</Bold> asked to retrieve private keys:
        </Text>
        { keys.map(key => (<Text>
          - <Bold>{key.role}</Bold> key (account index: <Italic>#{ String(key.accountIndex ?? 0) }</Italic>)
        </Text>))}
      </Box>
    )
  }
});
